<?php
	require_once("lib.php");

	$subtitle = "Add grade";
	auth($subtitle);
	$user = $_SESSION['user'];
	$db = db_connect();

	if ($_SERVER['REQUEST_METHOD'] != 'POST')
	{
		// Validate GET Input
		$course = validate($_GET['course'], $db);
		$section = validate($_GET['section'], $db, "numeric");
		$semester = validate($_GET['semester'], $db);
		$year = validate($_GET['year'], $db, "numeric");
		$assignment = validate($_GET['assignment'], $db);
		grade_form($db, $GLOBALS['TITLE'], $subtitle, $user, 'addgrade/', $course['html'], $section['html'], $semester['html'], $year['html'], $assignment['html']);
		exit();
	}

	// Validate Input
	$course = validate($_POST['course'], $db);
	$section = validate($_POST['section'], $db, "numeric");
	$semester = validate($_POST['semester'], $db);
	$year = validate($_POST['year'], $db, "numeric");
	$assignment = validate($_POST['assignment'], $db);
	$id = validate($_POST['id'], $db, "numeric");
	$grade = validate($_POST['grade'], $db, "numeric");

	// bunch of specific input validation, (this should be enforced by database, but mysql doesnt support check constraints)
	if ( $id['html'] == null && $grade['html'] == null)
	{
		grade_form($db, $GLOBALS['TITLE'], $subtitle, $user, 'addgrade/', $course['html'], $section['html'], $semester['html'], $year['html'], $assignment['html'], $id['html'], $grade['html'], "Id and Grade must be numeric.");
		exit();
	}
	else if ($id['html'] == null)
	{
		grade_form($db, $GLOBALS['TITLE'], $subtitle, $user, 'addgrade/', $course['html'], $section['html'], $semester['html'], $year['html'], $assignment['html'], $id['html'], $grade['html'], "Id must be numeric.");
		exit();
	}
	else if ($grade['html'] == null)
	{
		grade_form($db, $GLOBALS['TITLE'], $subtitle, $user, 'addgrade/', $course['html'], $section['html'], $semester['html'], $year['html'], $assignment['html'], $id['html'], $grade['html'], "Grade must be numeric.");
		exit();
	}
	else if ($grade['html'] == null)
	{
		grade_form($db, $GLOBALS['TITLE'], $subtitle, $user, 'addgrade/', $course['html'], $section['html'], $semester['html'], $year['html'], $assignment['html'], $id['html'], $grade['html'], "Grade must be numeric.");
		exit();
	}
	else if ($grade['html'] != -1 && $grade['html'] <= 0)
	{
		grade_form($db, $GLOBALS['TITLE'], $subtitle, $user, 'addgrade/', $course['html'], $section['html'], $semester['html'], $year['html'], $assignment['html'], $id['html'], $grade['html'], "Grade must be greater than zero.");
		exit();
	}

	$grade['html'] = ($grade['html'] == -1) ? 0 : $grade['html'];

	// Add grade
	$query = $db->query("INSERT INTO grades VALUES ('$course[sql]', $section[sql], '$semester[sql]', $year[sql], '$assignment[sql]', $id[sql], $grade[sql])");
	if (!DB::isError($query))
	{
		success_page($GLOBALS['TITLE'], $subtitle, $user, "assignment/$course[url]/$section[url]/$semester[url]/$year[url]/$assignment[url]/", "Grade added.");
		gradeAlert($course['sql'], $section['sql'], $semester['sql'], $year['sql'], $id['sql'], $assignment['html'], $grade['html'], $db);
	}
	else
	{
		$error = getError($query);
		error_page($GLOBALS['TITLE'], $subtitle, $user, "Failed to add grade: " . $error);
	}
?>