<?php
	require_once("lib.php");

	$subtitle = "Add section";
	auth($subtitle);
	$user = $_SESSION['user'];
	$db = db_connect();


	if ($_SERVER['REQUEST_METHOD'] != 'POST')
	{
		// Validate GET Input
		$course = validate($_GET['course'], $db);
		section_form($GLOBALS['TITLE'], $subtitle, $user, "addsection/", $course['html'], " ", " ", date("Y"));
		exit();
	}

	// Validate Input
	$course_key = validate($_POST['course_key'], $db);
	$section = validate($_POST['section'], $db, "numeric");
	$semester = validate($_POST['semester'], $db);
	$year = validate($_POST['year'], $db, "numeric");
	$instructor = validate($_POST['instructor'], $db);
	$schedule = validate($_POST['schedule'], $db);
	$location = validate($_POST['location'], $db);

	// bunch of specific input validation, (this should be enforced by database, but mysql doesnt support check constraints)
	$now = date("Y");
	$future = date("Y") + 5;
	if ($section['html'] == null && $year['html'] == null)
	{
		section_form($GLOBALS['TITLE'], $subtitle, $user, "addsection/", $course_key['html'], $section['html'], $semester['html'], $year['html'], $instructor['html'], $schedule['html'], $location['html'], "Section and year must be numeric.");
		exit();
	}
	else if ($section['html'] == null)
	{
		section_form($GLOBALS['TITLE'], $subtitle, $user, "addsection/", $course_key['html'], $section['html'], $semester['html'], $year['html'], $instructor['html'], $schedule['html'], $location['html'], "Section must be numeric.");
		exit();
	}
	else if ($year['html'] == null)
	{
		section_form($GLOBALS['TITLE'], $subtitle, $user, "addsection/", $course_key['html'], $section['html'], $semester['html'], $year['html'], $instructor['html'], $schedule['html'], $location['html'], "Year must be numeric.");
		exit();
	}
	else if ($section['html'] != -1 && $section['html'] <= 0)
	{
		section_form($GLOBALS['TITLE'], $subtitle, $user, "addsection/", $course_key['html'], $section['html'], $semester['html'], $year['html'], $instructor['html'], $schedule['html'], $location['html'], "Section must be greater than zero.");
		exit();
	}
	else if ($year['html'] != -1 && $year['html'] < $now || $year['html'] > $future)
	{
		section_form($GLOBALS['TITLE'], $subtitle, $user, "addsection/", $course_key['html'], $section['html'], $semester['html'], $year['html'], $instructor['html'], $schedule['html'], $location['html'], "Year must be between $now and $future.");
		exit();
	}

	// Add section
	$query = $db->query("INSERT INTO sections VALUES ('$course_key[sql]', $section[sql], '$semester[sql]', '$year[sql]', '$instructor[sql]', '$schedule[sql]', '$location[sql]')");
	if (!DB::isError($query))
	{
		success_page($GLOBALS['TITLE'], $subtitle, $user, "course/$course_key[url]/", "$course_key[html] Section $section[html] added.");
	}
	else
	{
		$error = getError($query);
		error_page($GLOBALS['TITLE'], $subtitle, $user, "Failed to add section: " . $error);
	}
?>