<?php
require "DB.php";
session_start();

// Title for all pages
$GLOBALS['TITLE'] = "Web-Grade";

// Base url used in meta refreshes (May not be required on some servers)
$GLOBALS['BASE_URL'] = "http://omega.uta.edu/~akw0152/cse3310";

// Email disable (Yeah, I accidently sent a few random people failing notices @uta.edu
$GLOBALS['EMAIL'] = 0;

// Debug level, non zero spits out detailed information (sql statements)
$GLOBALS['DEBUG'] = 1;

function db_connect()
{
	$mysql = array(
		'phptype'  => 'mysql',
		'username' => 'akw0152',
		'password' => '03128563',
		'hostspec' => 'omega',
		'database' => 'akw0152'
	);
	
	$oracle = array(
		'phptype'  => 'oci8',
		'username' => 'akw0152',
		'password' => 'h72gjphartwaagds',
		'hostspec' => 'omega.uta.edu',
		'database' => 'CSE1'
	);
	
	$pgsql = array(
		'phptype'  => 'pgsql',
		'username' => 'remote',
		'password' => 'h72gjphartwaagds',
		'hostspec' => 'localhost',
		'database' => 'webgrade'
	);


	$options = array(
		'debug'       => 2
	);

	// edit first parameter with your dsn
	$db = DB::connect($mysql, $options);
	if (DB::isError($db))
	{
		$error = $db->getMessage();
		echo "Connect error: $error";
		exit();
	}
	$db->setFetchMode(DB_FETCHMODE_OBJECT);
	return $db;
}

function validate($input, $db, $type = "string")
{
	$input = trim($input);

	if ( $input || ($input = 0 && $type == "numeric") )
	{
		if ($type == "numeric" and is_numeric($input) == false)
		{
			return null;
		}

		$array['html'] = htmlspecialchars($input, ENT_QUOTES);
		$array['sql'] = addslashes($array['html']);
		$array['url'] = urlencode($array['html']);
		return $array;
	}

	if ($type == "numeric")
	{
		$array['html'] = -1;
		$array['sql'] = -1;
		$array['url'] = -1;
	}
	else
	{
		$array['html'] = 'null';
		$array['sql'] = 'null';
		$array['url'] = 'null';
	}
	return $array;
}

function gradeAlert($course, $section, $semester, $year, $id, $assignment, $score, $db)
{
	if ($GLOBALS['EMAIL'] == 0)
	{
		return;
	}


	$grade = 0;
	$pSum = 0;

	$query = $db->query("SELECT grade, percentage FROM grades NATURAL JOIN assignments WHERE grades.course = '$course' and grades.section = $section and grades.semester = '$semester' and grades.year = $year and id = $id");
	if (DB::isError($query))
	{
		$error = getError($query);
		echo "Unexpected error: $error";
	}

	// Add up final grade percentage for each assignment and sum percentage total
	while ($row =& $query->fetchRow())
	{
		$grade += $row->grade * ($row->percentage / 100.0);
		$pSum += $row->percentage;
	}

	// calculate final grade at current total percentage
	if ($pSum)
	{
		$grade /= $pSum;
		$grade *= 100;
	}

	if ($grade < 70)
	{
		$query = $db->query("SELECT name, email FROM students, accounts WHERE students.username = accounts.username and students.id = $id");
		if (DB::isError($query))
		{
			$error = getError($query);
			echo "Unexpected error: $error";
		}
		$row =& $query->fetchRow();

		$body = sprintf("The student has recieved and automatic notice of his or her status via email. You may contact the student at $row->email\n\n$row->name scored a $score on $assignment and has a overall average of %3.2f.\n\nThis is an automatically generated email, replies are ignored.\n", $grade);
		mail("akw0152@omega.uta.edu", "Web-Grade: $row->name is failing.", $body, "From: akw0152@omega.uta.edu\r\n");
		$body = sprintf("You scored a $score on $assignment and have a overall average of %3.2f.\n\nThis is an automatically generated email, replies are ignored.\n", $grade);
		mail($row->email, "Web-Grade: You are failing $course", $body, "From: akw0152@omega.uta.edu\r\n");
	}
}

function graph($db, $course, $section, $semester, $year, $id = null)
{
	$getstring = "width=640&amp;height=120";
	$nPoints = 0;


	if ($id == null)
	{
		$query = $db->query("SELECT id from enrollment WHERE course = '$course' and section = '$section' and semester = '$semester' and year = '$year'");
	}
	else
	{
		// hacky and crappy
		$query = $db->query("SELECT id from enrollment WHERE course = '$course' and section = '$section' and semester = '$semester' and year = '$year' and id = $id");
	}

	if (DB::isError($query))
	{
		$error = getError($query);
		echo "Unexpected error: $error";
	}

	for ($i = 0; $row =& $query->fetchRow(); $i++)
	{
		$colors = array(24, 24, 114, 0, 128, 0, 255, 160, 122, 128, 0, 0,
			173, 255, 47, 255, 255, 0, 139, 0, 0, 255, 140, 0, 240, 248, 255 );

		$grade = 0;
		$pSum = 0;
	
		$query2 = $db->query("select grades.assignment, grades.grade, assignments.percentage, id from grades NATURAL JOIN assignments where grades.course = '$course' and grades.section = $section and grades.semester = '$semester' and grades.year = $year and grades.id = $row->id ORDER BY due");
		if (DB::isError($query2))
		{
			$error = getError($query2);
			echo "Unexpected error: $error";
		}

		// calculate final grade over time for each assignment
		for ($j = 0; $row =& $query2->fetchRow(); $j++)
		{
			$grade += $row->grade * ($row->percentage / 100.0);
			$pSum += $row->percentage;
	
			if ($pSum)
			{
				$average[$j] = $grade * 100 / $pSum;
			}
		}

		$nPoints = max($j, $nPoints);

		$r = $i * 3;
		$g = $i * 3 + 1;
		$b = $i * 3 + 2;
		$getstring .= "&amp;p$i-r=$colors[$r]&amp;p$i-g=$colors[$g]&amp;p$i-b=$colors[$b]";
		for ($j = 0; $j < $nPoints; $j++)
		{
			$getstring .= sprintf("&amp;p$i-$j=%3.0f", $average[$j] );
		}
	}

	$getstring .= "&amp;npoints=$nPoints&amp;ngraphs=$i";
	return $getstring;
}

function passStrength($password) 
{
	$strength = 0;
	$patterns = array('#[a-z]#','#[A-Z]#','#[0-9]#','/[!"$%^&*()`{}\[\]:@~;\'#<>?,.\/\\-=_+\|]/');
	foreach($patterns as $pattern)
	{
		if(preg_match($pattern, $password, $matches))
		{
			$strength++; 
		}
	}
	return $strength;
}

function getError($query)
{
	if ($GLOBALS['DEBUG'] == 0)
	{
		return $query->getMessage();
	}
	else
	{
		return $query->getDebugInfo();
	}
}

require "libhtml.php";
?>
