<?php
	require_once("lib.php");

	$subtitle = "Modify course";
	auth($subtitle);
	$user = $_SESSION['user'];
	$db = db_connect();

	if ($_SERVER['REQUEST_METHOD'] != 'POST')
	{
		// Validate GET input
		$course = validate($_GET['course'], $db);
		$title = validate($_GET['title'], $db);
		$credits = validate($_GET['credits'], $db, "numeric");
		$description = validate($_GET['description'], $db);
		course_form($GLOBALS['TITLE'], $subtitle, $user, "modifycourse/", $course['html'], $title['html'], $credits['html'], $description['html']); 
		exit();
	}

	// Validate input
	$course_key = validate($_POST['course_key'], $db);
	$course = validate($_POST['course'], $db);
	$title = validate($_POST['title'], $db);
	$credits = validate($_POST['credits'], $db, "numeric");
	$description = validate($_POST['description'], $db);

	// bunch of specific input validation, (this should be enforced by database, but mysql doesnt support check constraints)
	if ( $credits['html'] == null )
	{
		course_form($GLOBALS['TITLE'], $subtitle, $user, "addcourse/", $course['html'], $title['html'], $credits['html'], $description['html'], "Credits must be numeric"); 
		exit();
	}
	else if ($credits['html'] != -1 && $credits['html'] <= 0)
	{
		course_form($GLOBALS['TITLE'], $subtitle, $user, "addcourse/", $course['html'], $title['html'], $credits['html'], $description['html'], "Credits must be greater than zero"); 
		exit();
	}

	// modify course
	$query = $db->query("UPDATE courses SET course = '$course[sql]', title = '$title[sql]', credits = '$credits[sql]', description = '$description[sql]' WHERE course = '$course_key[sql]'");
	if (!DB::isError($query))
	{
		success_page($GLOBALS['TITLE'], $subtitle, $user, "index/", "Course modified.");
	}
	else
	{
		$error = getError($query);
		error_page($GLOBALS['TITLE'], $subtitle, $user, "Failed to modify course: " . $error);
	}
?>