<?php
	require_once("lib.php");

	$subtitle = "Report";
	auth($subtitle);
	$user = $_SESSION['user'];
	$db = db_connect();

	// Validate input
	$course = validate($_GET['course'], $db);
	$section = validate($_GET['section'], $db);
	$semester = validate($_GET['semester'], $db);
	$year = validate($_GET['year'], $db);
	$body = "Email report for $course[html]%0A(Assignment: Max Min Average Deviation)%0A";


	include "head.html";
	echo "<title>$GLOBALS[TITLE]: $subtitle</title>\n";
	include "header.html";
	echo "<div class=\"title\"><a class=\"index\" href=\"section/$course[url]/$section[url]/$semester[url]/$year[url]/\">$GLOBALS[TITLE]: $subtitle</a></div>\n";
	echo "<div>Logged in as $user - <a href=\"logout/\">Logout</a></div>";

	// Output report
	$query = $db->query("SELECT assignment, MAX(grade) AS max, MIN(grade) AS min, AVG(grade) AS avg, STDDEV(grade) AS dev FROM grades WHERE course = '$course[sql]' and section = '$section[sql]' and semester = '$semester[sql]' and year = '$year[sql]' GROUP BY assignment");
	if (DB::isError($query))
	{
		$error = getError($query);
		echo "Unexpected error: $error";
	}
	include "rgrey_header.html";
	echo "<div><span class=\"subtitle\">Summary for $course[html] Section $section[html]</span></div>";
	echo "<table>\n";
	echo "<tr><th>Assignment</th><th>Max</th><th>Min</th><th>Avg</th><th>Deviation</th></tr>\n";

	for ($i = 0; $row =& $query->fetchRow(); $i++)
	{
		$class = "row" . $i % 2;
		printf("<tr class=\"$class\"><td>$row->assignment</td><td>$row->max</td><td>$row->min</td><td>%3.2f</td><td>%3.2f</td></tr>\n", $row->avg, $row->dev);
		$body .= sprintf("$row->assignment: %3.2f %3.2f %3.2f %3.2f", $row->max, $row->min, $row->avg, $row->dev);
		$body .= "%0A";
	}
	echo "</table>\n";
	include "rgrey_footer.html";

	// Output progress
	$data = graph($db, $course['html'], $section['html'], $semester['html'], $year['html']);
	include "rgrey_header.html";
	echo "<div><span class=\"subtitle\">Class Progress</span></div>";
	echo "<div><img alt=\"Line Graph\" src=\"graph.php?$data\" /></div>";
	include "rgrey_footer.html";


	// Output assignments
	$query = $db->query("SELECT name, students.id, grade, assignment FROM students NATURAL JOIN grades WHERE course = '$course[sql]' and section = '$section[sql]' and semester = '$semester[sql]' and year = '$year[sql]'");
	if (DB::isError($query))
	{
		$error = getError($query);
		echo "Unexpected error: $error";
	}

	include "rgrey_header.html";
	echo "<div><span class=\"subtitle\">Report for $course[html] Section $section[html]</span></div>";
	echo "<table>\n";
	echo "<tr><th>Name</th><th>Id</th><th>Assignment</th><th>Grade</th></tr>\n";

	for ($i = 0; $row =& $query->fetchRow(); $i++)
	{
		$class = "row" . $i % 2;
		$id['url'] = urlencode($row->id);
		echo "<tr class=\"$class\"><td><a href=\"report/$course[url]/$section[url]/$semester[url]/$year[url]/$id[url]/\">$row->name</a></td><td>$row->id</td><td>$row->assignment</td><td class=\"center\">$row->grade</td></tr>\n";
	}
	echo "</table>\n";
	include "rgrey_footer.html";
	echo "<div class=\"nav\"><a href=\"index/\">Course List</a> - <a href=\"course/$course[url]/\">Section List</a> - <a href=\"section/$course[url]/$section[url]/$semester[url]/$year[url]/\">Section</a> - <a href=\"report/$course[url]/$section[url]/$semester[url]/$year[url]/\">Report</a> - <a href=\"mailto:admin@webgrade?subject=Report&amp;body=$body\">Email</a> - <a href=\"javascript:window.print()\">Print</a></div>";
	include "footer.html";
?>